moSetGetExtras = {};

local abs, ceil, floor, max, min, random, pow = math.abs, math.ceil, math.floor, math.max, math.min, math.random, math.pow;


--new LS 19
--ls 19 intern optional --> g_currentMission.environment:addMinuteChangeListener(self) --check your Table at environment 
function moSetGetExtras:addTimer(...) ---> table with optional values
	if MultiOverlayV3.timers == nil then MultiOverlayV3.timers = {};end;
	if ... ~= nil and type(...) == "table" then		
		local args = ...;				
		local delayMs = 1*100; -->1 mSec		
		local delay = 1*1000; -->default is 1 sec
		local action = nil;
		local repeatable = true; -->default endless (optional false=1x or integer for max runs)
		local timerReady = false;		
		for arg, value in pairs(args) do
			if arg == "ms" and type(args.ms) == "boolean" and args.ms then delay = delayMs;end;
			if arg == "delay" and type(args.delay) == "number" and args.delay > 1 then delay = args.delay*delay;end;
			if arg == "action" and type(args.action) == "function" then action = args.action;end;			
			if arg == "repeatable" and (type(args.repeatable) == "number" or type(args.repeatable) == "boolean") then repeatable = args.repeatable;end;
			if arg == "name" and type(args.name) == "string" and MultiOverlayV3.timers[args.name] == nil then				
				timerReady = true;
			end;	
			if MultiOverlayV3.timers["1sec"] == nil then --default Timers 1-60 sec. Add over MultiOverlayV3
				for a=1, moGeneralSettings.maxTimers do
					MultiOverlayV3.timers[tostring(a).. "sec"] = {current_time = 0, delay = a*1000, onOff= true, action = nil, repeatable = true, runs = true};
				end;				
			end;
			if MultiOverlayV3.timers["1mSec"] == nil then --default Timers 1-60 Milli-sec. Add over MultiOverlayV3
				for a=1, moGeneralSettings.maxTimers do
					MultiOverlayV3.timers[tostring(a).. "mSec"] = {current_time = 0, delay = a*100, onOff= true, action = nil, repeatable = true, runs = true};
				end;				
			end;
		end;
		if timerReady then 
			MultiOverlayV3.timers[args.name] = {current_time = 0, delay = delay, action = action, onOff = true, repeatable = repeatable, runs = true}; --with Timer Name (runs = true/false,set auto over Timers)
			return true;
		else 
			return false, "addTimer... Table name=.... not found/incorrect(needs string) or name already exists";
		end;
	end;
	return false, "addTimer... Table not Found or not a Table";
end;

function moSetGetExtras:update_timers(dt)
	if MultiOverlayV3.timers ~= nil then
		for name, timer in pairs(MultiOverlayV3.timers) do
			if MultiOverlayV3.timers[name] ~= nil then --for delete -timer check
				timer.current_time = timer.current_time + dt;
				if timer.current_time > timer.delay then
					if timer.onOff then timer.onOff = false;else timer.onOff = true;end; --onOff 1xon 1xoff all ..sec
					timer.runs = false; --1x all ..sec, blink effect oder auslöser						 
					if timer.action then timer.action();end;            
					if timer.repeatable then 
						if type(timer.repeatable) == "number" then
							timer.repeatable = timer.repeatable - 1
							if timer.repeatable >= 0 then 
								timer.current_time = 0;							
							else 
								MultiOverlayV3.timers[name] = nil; 
							end;
						else 
							timer.current_time = 0;						
						end;
					else
						MultiOverlayV3.timers[name] = nil;
					end;
				else
					timer.runs = true;
				end;
			end;
		end;
	end;
end;

function moSetGetExtras:runsTimer(name, onOff)
	if name == nil or type(name) ~= "string" then return nil;end;	
	if MultiOverlayV3.timers ~= nil and MultiOverlayV3.timers[name] ~= nil then		
		if onOff ~= nil and onOff then
			return MultiOverlayV3.timers[name].onOff, MultiOverlayV3.timers[name].repeatable;
		else
			return MultiOverlayV3.timers[name].runs, MultiOverlayV3.timers[name].repeatable;
		end;
	end;
	return nil;
end;

function moSetGetExtras:removeTimer(name)
	if name == nil or type(name) ~= "string" then return nil;end;
	if MultiOverlayV3.timers ~= nil and MultiOverlayV3.timers[name] ~= nil then
		MultiOverlayV3.timers[name] = nil;
		return true;
	end;
	return nil;
end;
--new LS 19

--old LS 17
function moSetGetExtras:createTimers(self)	
	local lenght = 250;
	local isTimersLenght = 0;	
	moGeneralSettings.timer = {};
	for a=0, moGeneralSettings.maxTimers do		
		moGeneralSettings.timer["getTimer".. a] = 0;
		if a == 0 then
			moGeneralSettings.timer["isTimer".. a] = 250;
		else
			isTimersLenght = isTimersLenght+lenght;
			moGeneralSettings.timer["isTimer".. a] = isTimersLenght;
		end;		
	end;	
end;

function moSetGetExtras:setTimers(self)	
	for a=0,moGeneralSettings.maxTimers do
		moGeneralSettings.timer["getTimer".. a] = moGeneralSettings.timer["getTimer".. a]+1;
		if moGeneralSettings.timer["getTimer".. a] >= moGeneralSettings.timer["isTimer".. a] then
			moGeneralSettings.timer["getTimer".. a] = 0;			
		end;
	end;
end;

function moSetGetExtras:getTimer(self, timer, greater)	
	if greater and moGeneralSettings.timer["getTimer".. timer] >= moGeneralSettings.timer["isTimer".. timer]/2 then 
		return true;
	elseif greater == nil or not greater and moGeneralSettings.timer["getTimer".. timer] < moGeneralSettings.timer["isTimer".. timer]/2 then 
		return true;
	end;
	return false;
end;
--old LS 17


function moSetGetExtras:getPlayerPos(noVehicle)
	if g_currentMission.controlledVehicle ~= nil then
		if noVehicle then return nil;end;
		if g_currentMission.controlledVehicle.steeringAxleNode ~= nil then
			return getWorldTranslation(g_currentMission.controlledVehicle.steeringAxleNode);
		end;
	else
		return g_currentMission.player:getPositionData();
	end;
	return nil;
end;

function moSetGetExtras:getColorForFarm(farmId)
    local farm = g_farmManager:getFarmById(farmId);
    if farm ~= nil then
        local color = Farm.COLORS[farm.color];
        if color ~= nil then        
			--if color[1] == 0 and (color[2] >= 0 and color[2] <= 0.1) and (color[3] == 1 or (color[3] > 0.1 and color[3] < 1)) then --! darkBlue zu dunkel !
			--	return {65/255, 105/255, 225/255, 1.00}; --royal blue
				--return {39/255,  64/255, 139/255, 1} --royal blue 4 zu hell
			--end;
			return {color[1], color[2], color[3], color[4]};
        end;
    end;
    return {1, 1, 1, 1};
end;

function moSetGetExtras:getNodeObject(object, gc)	
	if gc then
		if object == nil or object.rootNode == 0 then return nil;end;	
		local rootNode = getNumOfChildren(Utils.getNoNil(object.rootNode, 0));
		if rootNode == nil or rootNode == 0 then return nil;end;return rootNode;		
	else
		if object == nil or object.nodeId == 0 then return nil;end;	
		local nodeId = getNumOfChildren(Utils.getNoNil(object.nodeId, 0));
		if nodeId == nil or nodeId == 0 then return nil;end;return nodeId;
	end;
	return nil;
end;

function moSetGetExtras:getMilliSecondsToHours(sMilliSeconds, getHoursMin, getHoursSec)
	local nMilliSeconds = tonumber(sMilliSeconds);
	if nMilliSeconds == 0 then	
		return "0";
	else
		local nHours = string.format("%02.f", floor(nMilliSeconds/3600000));
		local nMins = string.format("%02.f", floor(nMilliSeconds/60000 - (nHours*60)));	
		local nSecs = string.format("%02.f", floor((nMilliSeconds/1000 - nHours*3600 - nMins*60)));
		if not getHoursMin then return nHours;end;				
		if getHoursMin and getHoursSec == nil then return nHours..":"..nMins;end;
		if getHoursMin and getHoursSec then return nHours..":"..nMins..":"..nSecs;end;
	end;
	return "0";
end;

function moSetGetExtras:getRealTime(getHours, getMin, getSec)
	if moGeneralSettings.timeFormat > 12 then 
		if getHours and not getMin and not getSec then return tostring(getDate("%H"));end;
		if not getHours and getMin and not getSec then return tostring(getDate("%M"));end;
		if not getHours and not getMin and getSec then return tostring(getDate("%S"));end;
		if getHours and getMin and not getSec then return tostring(getDate("%H:%M"));end;
		if getHours and getMin and getSec then return tostring(getDate("%H:%M:%S"));end;
	elseif moGeneralSettings.timeFormat <= 12 then
		if getHours and not getMin and not getSec then return tostring(getDate("%I")).. string.lower(getDate("%p"));end;
		if not getHours and getMin and not getSec then return tostring(getDate("%M")).. string.lower(getDate("%p"));end;
		if not getHours and not getMin and getSec then return tostring(getDate("%S")).. string.lower(getDate("%p"));end;
		if getHours and getMin and not getSec then return tostring(getDate("%I:%M")).. string.lower(getDate("%p"));end;
		if getHours and getMin and getSec then return tostring(getDate("%I:%M:%S")).. string.lower(getDate("%p"));end;
	end;
	return "0";
end;

function moSetGetExtras:getRealDay(day, weekday, month, year)
	if day and not weekday and not month and not year then return getDate("%d");end;
	if weekday and not day and not month and not year then return getDate("%w");end; --math.mod(getDate("%w"), 7);end;
	if month and not day and not weekday and not year then return getDate("%m");end;
	if year and not day and not weekday and not month then return getDate("%Y");end;
	
	if weekday and day and month and not year then return getDate("%d"), getDate("%w"), getDate("%m");end;
	if weekday and day and month and year then return getDate("%d"), getDate("%w"), getDate("%m"), getDate("%Y");end;
	return 1, 1, 1, 1;
end;

function moSetGetExtras:getInGameDay(currentDay, weekday)	
	local tempCurrentDay = 1;
	--Sicherheitsabfrage bei inGameDay Error bei einigen Usern
	if g_currentMission ~= nil and g_currentMission.environment ~= nil and g_currentMission.environment.currentDay ~= nil then tempCurrentDay = g_currentMission.environment.currentDay;
	elseif g_currentMission ~= nil and g_currentMission.missionInfo ~= nil and g_currentMission.missionInfo.currentDay ~= nil then tempCurrentDay = g_currentMission.missionInfo.currentDay;end;
	--Sicherheitsabfrage bei inGameDay Error bei einigen Usern
	if currentDay and not weekday then return tempCurrentDay;end;
	if not currentDay and weekday then return math.mod(tempCurrentDay, 7);end;
	if currentDay and weekday then return tempCurrentDay, math.mod(tempCurrentDay, 7);end;
	return 1, 1;
end;

function moSetGetExtras:getDayNight()
	local dayTime = g_currentMission.environment.dayTime/(1000*60);
	return dayTime > (g_currentMission.environment.nightStartMinutes+30) or dayTime < (g_currentMission.environment.nightEndMinutes-30);
end;

function moSetGetExtras:getCloudScale(seasons)
	local cloud = 0;
	if not seasons then 
		cloud = g_currentMission.environment.weather.cloudUpdater.currentCloudCoverage;
	else
		cloud = g_seasons.mission.environment.weather.cloudUpdater.currentCloudCoverage;
	end;	
	return cloud*10;
end;

function moSetGetExtras:getFogScale()
	local fog = g_currentMission.environment.weather.fogUpdater.currentMieScale;	
	return fog;
end;

function moSetGetExtras:getWindScale()
	local wind = g_currentMission.environment.weather.windUpdater.currentVelocity;	
	--moGeneralSettings.testNumber = "Wind ".. tostring(wind);
	return string.format("%2.f", floor(wind+0.5));
	--return wind;
end;

function moSetGetExtras:getRainScale()
	local instance = g_currentMission.environment.weather.forecastItems[1];
	if instance ~= nil then
		local object = g_currentMission.environment.weather:getWeatherObjectByIndex(instance.objectIndex);
		if object.getRainFallScale ~= nil then
			return object:getRainFallScale();
		end;
	end;
	return 0;
end;

function moSetGetExtras:getTemperature()
	local maxTemp = 0;
	local minTemp = 0;
	local dayTemp = 0;
	local nightTemp = 0;
	local trend = 0;
	local isTemp = nil;
	if MultiOverlayV3.otherMods.seasons ~= nil or g_seasons ~= nil then		
		local minTemp1, maxTemp1 = g_seasons.weather.forecast.items[1].lowTemp, g_seasons.weather.forecast.items[1].highTemp;
		maxTemp = g_i18n:getTemperature(maxTemp1);
		minTemp = g_i18n:getTemperature(minTemp1);		
	else
		minTemp, maxTemp = g_currentMission.environment.weather:getCurrentMinMaxTemperatures();		
		trend = g_currentMission.environment.weather:getCurrentTemperatureTrend();
	end;
	local isTemp = (maxTemp + minTemp) / 2;
	dayTemp = string.format("%d", maxTemp);
	nightTemp = string.format("%d", minTemp);
	return trend, isTemp, dayTemp, nightTemp;
end;

function moSetGetExtras:getSoilTemperature()	
	return g_i18n:formatTemperature(g_seasons.weather.soilTemp, 0, false);	
end;

function moSetGetExtras:getSeasonCurrentDay()	
	local day = g_seasons.environment.currentDay;
	--moGeneralSettings.testString = "Season Day ".. tostring(day);
	return day;
end;

function moSetGetExtras:getInSeasonDay()
	local day = g_seasons.environment.dayInSeason;	
	--moGeneralSettings.testString = "Season Day ".. tostring(day);
	return day;
end;

function moSetGetExtras:getSeasonPeriod()
	local period = g_seasons.environment.period;
	--moGeneralSettings.testString1 = "Season Period ".. tostring(period);
end;

function moSetGetExtras:isCropFrozen()
	local isFrozenOn = g_seasons.weather.airWasFrozen;
	local isVisible = g_seasons.ui.hud.frozenStateIcon:getVisible();
	--moGeneralSettings.testString = "Frost=".. tostring(isVisible)
	return isFrozenOn, isVisible;
end;

function moSetGetExtras:isCropMoisture()
	local isCropMoistureOn = g_seasons.weather.cropMoistureEnabled;
	local isVisible = g_seasons.ui.hud.moistStateIcon:getVisible();
	--moGeneralSettings.testString1 = "Feuchtigkeit=".. tostring(isVisible)
	return isCropMoistureOn, isVisible;
end;

function moSetGetExtras:getCurrentAndNextWeather()
    if MultiOverlayV3.otherMods.seasons ~= nil or g_seasons ~= nil then	
		--local day = moSetGetExtras:getSeasonCurrentDay();
		--local firstDay = g_seasons.weather.forecast.items[1].day;
		--local dayNextWeather = g_seasons.weather.forecast.items[day + 1 - firstDay + 1];
		--local dayNextWeather = g_seasons.weather.forecast.items[2];
		--local dayCurrentWeather = g_seasons.weather.forecast.items[day];
		--local dayCurrentWeather = g_seasons.weather.forecast.items[1];
		--local typ1, typ1_1 = moSetGetExtras:convertWeather(dayCurrentWeather.forecastType);
		--local typ2, typ2_2 = moSetGetExtras:convertWeather(dayNextWeather.forecastType);
		local typ1, typ1_1 = moSetGetExtras:convertWeather(g_seasons.ui.hud.gameInfoDisplay.currentWeather);
		local typ2, typ2_2 = moSetGetExtras:convertWeather(g_seasons.ui.hud.gameInfoDisplay.nextWeather);
		
		--moGeneralSettings.testString = "defaultcurrent=".. tostring(g_seasons.ui.hud.gameInfoDisplay.currentWeather).. " defaultnext=".. tostring(g_seasons.ui.hud.gameInfoDisplay.nextWeather);
		--moGeneralSettings.testString1 = "current=".. tostring(typ1).. ",".. tostring(typ1_1).. " next=".. tostring(typ2).. ",".. tostring(typ2_2);
		return true, typ1, typ1_1, typ2, typ2_2;
	else
		local typ1, typ1_1 = moSetGetExtras:convertWeather(g_currentMission.hud.gameInfoDisplay.currentWeather);
		local typ2, typ2_2 = moSetGetExtras:convertWeather(g_currentMission.hud.gameInfoDisplay.nextWeather);
		--moGeneralSettings.testString = "defaultcurrent=".. tostring(g_currentMission.hud.gameInfoDisplay.currentWeather).. " defaultnext=".. tostring(g_currentMission.hud.gameInfoDisplay.nextWeather);
		--moGeneralSettings.testString1 = "current=".. tostring(typ1).. ",".. tostring(typ1_1).. " next=".. tostring(typ2).. ",".. tostring(typ2_2);
		return false, typ1, typ1_1, typ2, typ2_2;
	end;
end;

function moSetGetExtras:convertWeather(typ)
	--SeasonsWeather.FORECAST_SUN = 0
	--SeasonsWeather.FORECAST_PARTLY_CLOUDY = 1
	--SeasonsWeather.FORECAST_RAIN_SHOWERS = 2
	--SeasonsWeather.FORECAST_SNOW_SHOWERS = 3
	--SeasonsWeather.FORECAST_SLEET = 4
	--SeasonsWeather.FORECAST_CLOUDY = 5
	--SeasonsWeather.FORECAST_RAIN = 6
	--SeasonsWeather.FORECAST_SNOW = 7
	--SeasonsWeather.FORECAST_FOG = 8
	--SeasonsWeather.FORECAST_THUNDER = 9
	--SeasonsWeather.FORECAST_HAIL = 10
	--2 sun, 3 cloudy, 4 rain, 5 snow, 6 sleet, 7 hail, 8 fog, 9 thunder, 10 smallcloudy
	if MultiOverlayV3.otherMods.seasons ~= nil or g_seasons ~= nil then
		if typ == 0 then return 2,2;end;
		if typ == 2 or typ == 6 then return 3,4;end;
		if typ == 5 then return 3,3;end;
		if typ == 1 then return 2,3;end;
		if typ == 3 or typ == 7 then return 3,5;end;
		if typ == 4 then return 3,6;end;
		if typ == 8 then return 3,8;end;
		if typ == 9 then return 3,9;end;
		if typ == 10 then return 3,7;end;		
	else
		if typ == 1 then return 2,2;end;
		if typ == 2 then return 3,3;end;
		if typ == 3 then return 3,4;end;		
	end;
	return 2,2;
end;

function moSetGetExtras:getWeatherDayTime()
	--#g_seasons.weather.forecast.items
	
	if g_currentMission.environment.weather.forecastItems ~= nil and #g_currentMission.environment.weather.forecastItems >= 2 then		
		local hours24 = 86400000;
		local currentInstance = g_currentMission.environment.weather.forecastItems[1];
		local currentStartDay = currentInstance.startDay;
		local currentStartTime = currentInstance.startDayTime;
		local currentDuration = currentInstance.duration;
		local currentEndTime = currentInstance.startDayTime+currentDuration;
		if currentEndTime > hours24 then currentEndTime = currentEndTime-hours24;end;
				
		local nextInstance = g_currentMission.environment.weather.forecastItems[2];
		local nextStartDay = nextInstance.startDay;
		local nextStartTime = nextInstance.startDayTime;
		local nextDuration = nextInstance.duration;
		local nextEndTime = nextInstance.startDayTime+nextDuration;		
		if nextEndTime > hours24 then nextEndTime = nextEndTime-hours24;end;
		
		local currentEndTimeTimer = g_currentMission.environment.dayTime-currentEndTime;
		local currentEndTimeTimerString = moSetGetExtras:getMilliSecondsToHours(currentEndTimeTimer, true);
		
		local nextStartTimeString = moSetGetExtras:getMilliSecondsToHours(nextStartTime, true);
		local nextEndTimeString = moSetGetExtras:getMilliSecondsToHours(nextEndTime, true);
		
		
		local currentEndTimeString = moSetGetExtras:getMilliSecondsToHours(currentEndTime, true);
		--local startTimeString = Utils.formatTime(startTime/3600000);
		--local endTimeString = Utils.formatTime(endTime/3600000);
		--local endTimeCurrentString = Utils.formatTime(endTimeCurrent/3600000);
		--return startDay, moSetGetExtras:getMilliSecondsToHours(startTime, true, false), moSetGetExtras:getMilliSecondsToHours(startTime+sixHours, true, false);
		--moGeneralSettings.testString1 = "NextStartTime ".. tostring(nextStartTimeString).. " -NextEndTime ".. tostring(nextEndTimeString).. " -CurrentEndTime ".. tostring(currentEndTimeString)
		return currentEndTimeTimerString, currentEndTimeString, nextStartTimeString, nextEndTimeString;
	end;
	--local sixHours = 21600000;
	--local env = g_currentMission.environment;
	--local dayPlus6h, timePlus6h = env:getDayAndDayTime(env.dayTime + sixHours, env.currentDay);
	--local weatherState = env.weather:getWeatherTypeAtTime(env.currentDay, env.dayTime);
	--local nextWeatherState = env.weather:getWeatherTypeAtTime(dayPlus6h, timePlus6h);	
	--return weatherState, nextWeatherState;
	return "","","","";
end;

function moSetGetExtras:getRealTimeOld(getHours, getMin, getSec)
	if getHours and not getMin and not getSec then return tostring(getDate("%H"));end;
	if getHours and getMin and not getSec then return tostring(getDate("%H:%M"));end;
	if getHours and getMin and getSec then return tostring(getDate("%H:%M:%S"));end;
	return "0";
end;

function moSetGetExtras:optiHeightSize(self, height, txtString, defaultSize)
	local txtHeight = getTextHeight(defaultSize, tostring(txtString));
	local default = defaultSize;
	if txtHeight > height then
		local i = 0;
		while txtHeight > height do
			i = i + 0.0005;
			txtHeight = getTextHeight(defaultSize-i, tostring(txtString));
		end
		return defaultSize-i;	
	end;
	return default;
end;

function moSetGetExtras:getWidthOptimalSize(width, txtString, defaultSize)
	local length = getTextWidth(defaultSize, tostring(txtString));
	local default = defaultSize;
	if length > width then
		local i = 0;
		while length > width do
			i = i + 0.0005;
			length = getTextWidth(defaultSize-i, tostring(txtString));
		end
		return defaultSize-i;
	end;
	return default;
end;

function moSetGetExtras:getWidthTxt(width, txtString, size, widthFix)
	local length = getTextWidth(size, tostring(txtString));
	local txtLen = string.len(tostring(txtString))+widthFix;
	if length > width then
		local i = 0;
		while length > width do
			i = i + 1;
			txtLen = txtLen-i;
			length = getTextWidth(size, string.sub(tostring(txtString), 1, txtLen));
		end;
	end;
	if txtLen <= 0 then txtLen = 1;end;
	return string.sub(tostring(txtString), 1, txtLen);
end;

function moSetGetExtras:setSideNotifications(onStart)
	if onStart then
		moGeneralSettings.sideNotifications.origY = SideNotification.POSITION.SELF[2];
		moGeneralSettings.sideNotifications.origDuration = SideNotification.FADE_DURATION;
	end;
	if moGeneralSettings.sideNotifications.upDownFix ~= 0 then
		SideNotification.POSITION.SELF[2] = moGeneralSettings.sideNotifications.origY+(moGeneralSettings.sideNotifications.upDownFix*10);		
	else
		SideNotification.POSITION.SELF[2] = moGeneralSettings.sideNotifications.origY;
	end;	
	if not onStart then	
		if #g_currentMission.hud.sideNotifications.notificationQueue == 0 then
			g_currentMission:addIngameNotification(FSBaseMission.INGAME_NOTIFICATION_CRITICAL, "Test Notification");
		end;
	end;
end;

function moSetGetExtras:setWTM(onStart)	
	if onStart then		
		local defaultPageSide = 1; --ändern wenn die seite verschoben wird
		local getThisButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=defaultPageSide, name="wtm_"} );			
		if getThisButtonPage == nil then return;end;		
		local guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].side[getThisButtonPage.pageSide];
		if getThisButtonPage.slavePage ~= nil then guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].page[getThisButtonPage.slavePage].side[getThisButtonPage.pageSide];end;
		local buttonTable = Utils.getNoNil(guiPageTable.line[getThisButtonPage.line].button[getThisButtonPage.button], nil);
		if buttonTable ~= nil then					
			local selectLine = {};
			table.insert(selectLine, MultiOverlayV3.wtm.weatherBox);
			table.insert(selectLine, MultiOverlayV3.wtm.showTime);
			table.insert(selectLine, MultiOverlayV3.wtm.showMoney);
			table.insert(selectLine, MultiOverlayV3.wtm.temperatureBox);
			table.insert(selectLine, MultiOverlayV3.wtm.seasonBox);
			table.insert(selectLine, MultiOverlayV3.wtm.stateBox);
			moSetGetGuiMenue:resetSelectPullDownLine(self, nil, nil, buttonTable, selectLine, true);		
		end;
	end;
	if MultiOverlayV3.otherMods.seasons ~= nil or g_seasons ~= nil then
		g_seasons.ui.hud.seasonBox:setVisible(MultiOverlayV3.wtm.seasonBox);			
		if MultiOverlayV3.wtm.seasonBox then
			g_seasons.ui:onDayChanged();			
		end;
		g_seasons.ui.hud.temperatureBox:setVisible(MultiOverlayV3.wtm.temperatureBox);
		if MultiOverlayV3.wtm.temperatureBox then				
			g_seasons.ui:onHourChanged();
		end;			
		g_seasons.ui.hud.gameInfoDisplay.weatherBox:setVisible(MultiOverlayV3.wtm.weatherBox);					
		g_seasons.ui.hud.gameInfoDisplay.showTime = MultiOverlayV3.wtm.showTime;
		g_seasons.ui.hud.gameInfoDisplay.timeBox:setVisible(MultiOverlayV3.wtm.showTime);
		g_seasons.ui.hud.gameInfoDisplay.showMoney = MultiOverlayV3.wtm.showMoney;
		g_seasons.ui.hud.gameInfoDisplay.moneyBox:setVisible(MultiOverlayV3.wtm.showMoney);
	end;
	g_currentMission.hud.gameInfoDisplay.weatherBox:setVisible(MultiOverlayV3.wtm.weatherBox);
	g_currentMission.hud.gameInfoDisplay.showTime = MultiOverlayV3.wtm.showTime;
	g_currentMission.hud.gameInfoDisplay.timeBox:setVisible(MultiOverlayV3.wtm.showTime);
	g_currentMission.hud.gameInfoDisplay.showMoney = MultiOverlayV3.wtm.showMoney
	g_currentMission.hud.gameInfoDisplay.moneyBox:setVisible(MultiOverlayV3.wtm.showMoney);
end;

function moSetGetExtras:seasonsState()
	oldSeasonsStateHUD = MultiOverlayV3.otherMods.seasons.SeasonsHUD.setInfoState;
	MultiOverlayV3.otherMods.seasons.SeasonsHUD.setInfoState = function (self, state)
		local isOkay, result = pcall(oldSeasonsStateHUD, self, state);
		if isOkay and self ~= nil and not MultiOverlayV3.wtm.stateBox then		
			self.stateBox:setVisible(false);		
		end;	
	end;
end;

function moSetGetExtras:seasonsDateText()
	oldSeasonsDateTextHUD = MultiOverlayV3.otherMods.seasons.SeasonsHUD.drawDateText;
	MultiOverlayV3.otherMods.seasons.SeasonsHUD.drawDateText = function (self)
		local isOkay, result = pcall(oldSeasonsDateTextHUD, self);
		if isOkay and self ~= nil and not MultiOverlayV3.wtm.seasonBox then		
			self.dateText = "";						
		end;	
	end;
end;

function moSetGetExtras:seasonsTemperatureText()
	oldSeasonsTemperatureTextHUD = MultiOverlayV3.otherMods.seasons.SeasonsHUD.drawTemperatures;
	MultiOverlayV3.otherMods.seasons.SeasonsHUD.drawTemperatures = function (self)
		local isOkay, result = pcall(oldSeasonsTemperatureTextHUD, self);
		if isOkay and self ~= nil and not MultiOverlayV3.wtm.temperatureBox then		
			self.airTemperature = "";
			self.soilTemperature = "";
		end;	
	end;
end;

function moSetGetExtras:setClock(overlaySmall, overlayLarge, centerX, centerY)
	local currentTime = g_currentMission.environment.dayTime / 3600000;
	local timeHours = math.floor(currentTime);	
	local hourRotation = -(currentTime % 12 / 12) * math.pi * 2;
	local minutesRotation = -(currentTime - timeHours) * math.pi * 2;
	local tempCenterX = centerX or 0;
	local tempCenterY = centerY or 0
	setOverlayRotation(overlaySmall.overlayId, hourRotation, 0+tempCenterX, 0+tempCenterY);
	setOverlayRotation(overlayLarge.overlayId, minutesRotation, 0+tempCenterX, 0+tempCenterY);
	--overlaySmall:setRotation(hourRotation);
	--overlayLarge:setRotation(minutesRotation);
end;

function moSetGetExtras:playerHandTool()
	oldPlayerStateCycleHandtool = PlayerStateCycleHandtool.isAvailable;
	PlayerStateCycleHandtool.isAvailable = function (self)
		local isOkay, result = pcall(oldPlayerStateCycleHandtool, self);
		if isOkay and self ~= nil then
			if not moGeneralSettings.other.handToolsSwitch then return false;end;			
			return result;
		end;
	end;	
end;

function moSetGetExtras:getDigiClock(sMilliSeconds, getHour, getMin, getSec)
	if moSetGetOverlays.foreignIcons["digiClock"] ~= nil and #moSetGetOverlays.foreignIcons["digiClock"] > 0 then
		local digiClock = {hours={[1]={},[2]={}},minutes={[1]={},[2]={}},seconds={[1]={},[2]={}}};
		local nMilliSeconds = tonumber(sMilliSeconds);
		if nMilliSeconds == 0 then	
			return nil;
		end;	
		local nHours = string.format("%02.f", floor(nMilliSeconds/3600000));
		local nMins = string.format("%02.f", floor(nMilliSeconds/60000 - (nHours*60)));	
		local nSecs = string.format("%02.f", floor((nMilliSeconds/1000 - nHours*3600 - nMins*60)));		
		local fInt = {};
		fInt[0]={3,4,5,6,7,8};fInt[1]={4,5};fInt[2]={3,4,6,7,9};fInt[3]={3,4,5,6,9};fInt[4]={4,5,8,9};fInt[5]={3,5,6,8,9};fInt[6]={3,5,6,7,8,9};fInt[7]={3,4,5,8};fInt[8]={3,4,5,6,7,8,9};fInt[9]={3,4,5,6,8,9};
		local eInt = {}
		eInt[0]={10,11,12,13,14,15};eInt[1]={11,12};eInt[2]={10,11,13,14,16};eInt[3]={10,11,12,13,16};eInt[4]={11,12,15,16};eInt[5]={10,12,13,15,16};eInt[6]={10,12,13,14,15,16};eInt[7]={10,11,12,15};eInt[8]={10,11,12,13,14,15,16};eInt[9]={10,11,12,13,15,16};
		if getHour then
			local hour1 = tonumber(string.sub(nHours, 1, 1));
			local hour2 = tonumber(string.sub(nHours, 2, 2));			
			if hour1 > 0 then digiClock.hours[1] = fInt[hour1];end;
			digiClock.hours[2] = eInt[hour2];			
		end;
		if getMin then
			local mins1 = tonumber(string.sub(nMins, 1, 1));
			local mins2 = tonumber(string.sub(nMins, 2, 2));
			digiClock.minutes[1] = fInt[mins1];
			digiClock.minutes[2] = eInt[mins2];			
		end;
		if getSec then
			local sec1 = tonumber(string.sub(nSecs, 1, 1));
			local sec2 = tonumber(string.sub(nSecs, 2, 2));
			digiClock.seconds[1] = fInt[sec1];
			digiClock.seconds[2] = eInt[sec2];			
		end;		
		return digiClock;
	end;
	return nil;
end;

function moSetGetExtras:getRandomColor(wert1, wert2)
	return random(wert1, wert2), random(wert1, wert2), random(wert1, wert2);
end;

--old later delete
moSetGetExtras.colors = {	
	own =       		{ 255/255, 255/255, 255/255, 1.00 };
	ownDisabled =   	{ 255/255, 255/255, 255/255, 0.80 };
	ownSilo =       	{ 	0/255,   0/255,   0/255, 1.00 };
	ownPrice =      	{ 255/255, 255/255, 255/255, 1.00 };
	ownBestPrice =  	{ 	0/255, 255/255,   0/255, 0.80 };
	ownDemand =     	{   4/255,  98/255, 180/255, 1.00 }; 	
	randomValues =  	{ 255/255, 255/255, 255/255, 1.00 };
	randomValuesOff =	{ 255/255, 255/255, 255/255, 0.80 };
	transparent =   	{  33/255,  48/255,  24/255, 0.50 };	
	darkYellow =   		{ 255/255, 161/255,  17/255, 1.00 };
	darkYellowOff =  	{ 255/255, 161/255,  17/255, 0.80 };
	white =         	{ 255/255, 255/255, 255/255, 1.00 };	
	whiteInactive = 	{ 255/255, 255/255, 255/255, 0.75 };
	whiteDisabled = 	{ 255/255, 255/255, 255/255, 0.15 };
	hover =         	{   4/255,  98/255, 180/255, 1.00 };
	hoverBestPrice =	{   4/255,  98/255, 180/255, 0.70 };
	darkBlue =	 		{ 	0/255,   0/255, 139/255, 1.00 };
	blue =	 			{ 	0/255,   0/255, 255/255, 1.00 };
	activeGreen =   	{  43/255, 205/255,  10/255, 1.00 }; 
	activeRed =    	 	{ 153/255,  22/255,  19/255, 1.00 }; 
	closeRed =      	{ 116/255,   0/255,   0/255, 1.00 }; 
	warningRed =    	{ 222/255,   2/255,   3/255, 1.00 };
	red =      			{ 255/255,   0/255,   0/255, 1.00 };
	redDisabled =   	{ 255/255,   0/255,   0/255, 0.80 };
	darkRed = 			{ 205/255,   0/255,   0/255, 1.00 };
	shadow =        	{   4/255,   4/255,   4/255, 1.00 }; 
	textDark =      	{   1/255,   1/255,   1/255, 1.00 };
	yellow =        	{ 255/255, 255/255,   0/255, 1.00 };
	yellowDisabled =	{ 255/255, 255/255,   0/255, 0.80 };
	yellowGreen =		{ 154/255, 205/255,  50/255, 1.00 };
	yellow1 =			{ 238/255, 221/255, 130/255, 1.00 };
	gold =				{ 255/255, 215/255,   0/255, 1.00 };
	green =        		{ 	0/255, 255/255,   0/255, 1.00 };
	darkOliveGreen =    {  85/255, 107/255,  47/255, 1.00 };
	greenDisabled = 	{ 	0/255, 255/255,   0/255, 0.80 };
	darkGreen = 		{ 	0/255, 100/255,   0/255, 1.00 };
	lightGreen =   		{ 144/255, 238/255, 144/255, 1.00 };
	chartreuse4 =		{  69/255,  139/255,  0/255, 1.00 };
	happylooser =   	{ 143/255, 188/255, 143/255, 1.00 };---
	happylooserOff= 	{ 143/255, 188/255, 143/255, 0.80 };---
	gray = 				{ 190/255, 190/255, 190/255, 1.00 };
	darkGray = 			{  87/255,  87/255,  87/255, 1.00 };
	black =        		{ 	0/255,   0/255,   0/255, 1.00 };
	blackInactive = 	{ 	0/255,   0/255,   0/255, 0.75 };
	orange =        	{ 255/255, 165/255,   0/255, 1.00 };
	orangeRed =        	{ 255/255,  55/255,   0/255, 1.00 };
	khaki =         	{ 240/255, 230/255, 140/255, 1.00 };
	ls15 =          	{   0/255, 255/255, 255/255, 1.00 };
	ls15Disabled =  	{   0/255, 255/255, 255/255, 0.80 };
	mangenta =  		{ 255/255, 	 0/255, 255/255, 1.00 };
	deepPink =  		{ 255/255, 020/255, 147/255, 1.00 };
	purple =  			{ 160/255, 032/255, 240/255, 1.00 };
};

function moSetGetExtras:getAllowedCharacters()
	local allowedSpan = { from = 32, to = 591 };
	local prohibitedUnicodes = { [34] = true, [39] = true, [94] = true, [96] = true, [215] = true, [247] = true };
	for unicode=127,190 do
		prohibitedUnicodes[unicode] = true;
	end;
	local result = {};
	for unicode=allowedSpan.from,allowedSpan.to do
		prohibitedUnicodes[unicode] = prohibitedUnicodes[unicode] or false;
		result[unicode] = not prohibitedUnicodes[unicode] and getCanRenderUnicode(unicode);
		--if getCanRenderUnicode(unicode) then
			--print(string.format('allowedCharacters[%d]=%s (%q) (prohibited=%s, getCanRenderUnicode()=true)', unicode, tostring(result[unicode]), unicodeToUtf8(unicode), tostring(prohibitedUnicodes[unicode])));
			--print("-unicode:".. unicode, "-result:".. tostring(result[unicode]), "-unicodeToUtf8:".. unicodeToUtf8(unicode), "-prohibited..:".. tostring(prohibitedUnicodes[unicode]));
		--end;
	end;
	return result;
end;

function moSetGetExtras:getUtf8normalization()
	local result = {};
	local normalizationSpans = {
		a  = { {192,195}, 197, {224,227}, 229, {256,261} },
		ae = { 196, 198, 228, 230 },
		c  = { 199, 231, {262,269} },
		d  = { {270,273} },
		e  = { {200,203}, {232,235}, {274,283} },
		g  = { {284,291} },
		h  = { {292,295} },
		i  = { {204,207}, {236,239}, {296,307} },
		j  = { {308,309} },
		k  = { {310,312} },
		l  = { {313,322} },
		n  = { 209, 241, {323,331} },
		o  = { {210,213}, {242,245}, {332,337} },
		oe = { 214, 216, 246, 248, 338, 339 },
		r  = { {340,345} },
		s  = { {346,353}, 383 },
		ss = { 223 },
		t  = { {354,359} },
		u  = { {217,219}, {249,251}, {360,371} },
		ue = { 220, 252 },
		w  = { 372, 373 },
		y  = { 221, 253, 255, {374,376} },
		z  = { {377,382} }
	};
	for normal,unicodes in pairs(normalizationSpans) do
		for _,data in pairs(unicodes) do
			if type(data) == "number" then
				local utf8 = unicodeToUtf8(data);
				result[utf8] = normal;
				if false and getCanRenderUnicode(data) then
					--print(string.format("MultiOverlayV3.utf8normalization[%q] = %q", utf8, normal));
				end;
			elseif type(data) == "table" then
				for unicode=data[1],data[2] do
					local utf8 = unicodeToUtf8(unicode);
					result[utf8] = normal;
					if false and getCanRenderUnicode(unicode) then
						--print(string.format("MultiOverlayV3.utf8normalization[%q] = %q", utf8, normal));
					end;
				end;
			end;
		end;
	end;
	return result;
end;

function moSetGetExtras:onIsUnicodeAllowed(unicode)
	return MultiOverlayV3.allowedCharacters[unicode] == true;
end;